<?php
require_once MODULE_REALDIR . 'mdl_dchk/class/pages/LC_Page_Mdl_Dchk.php';
require_once MODULE_REALDIR . 'mdl_dchk/class/helper/SC_Helper_Mail_Ex_Dchk.php';

class LC_Page_Mdl_Dchk_Convenience extends LC_Page_Mdl_Dchk {
    
    /**
     * 決済方法を取得します。
     */
    function getStore() {
      return $this->store;
    }
    
    function action(){
        $this->tpl_mainpage = LC_Helper_Mdl_Dchk::getTemplateDir('convenience.tpl');
        $this->shop_id = $this->convenience_shop_id;
        $this->shop_pass = $this->convenience_shop_pass;

        $objSiteSess = new SC_SiteSession_Ex();
        $objPurchase = new SC_Helper_Purchase_Ex();

        $objFormParam = new SC_FormParam_Ex();
        $this->initParam($objFormParam);
        $objFormParam->setParam($_POST);
        $this->arrConvenience = LC_Helper_Mdl_Dchk::getConvenienceArray();

        foreach($this->arrConvenience as $key=>$val){
            if(!in_array($key,$this->convenience)){
                unset($this->arrConvenience[$key]);
            }
        }
        
        $order_id = $_SESSION['order_id'];

        $arrOrderData = $objPurchase->getOrder($order_id);
        
        if ($arrOrderData['payment_total'] == 0) {
            $this->skipSettlement($order_id);
        }

        if ($arrOrderData['del_flg'] == 1) {
            $this->arrEr = array("message"=>"不正なページ遷移が行われました。");
            LC_Helper_Mdl_Dchk::log("不正なページ遷移が行われました。[SID:".$order_id."]");
            $this->viewError();
            exit;
        }

        switch ($_POST['mode']) {
            case "return":
                $this->rollbackUsePoint($order_id);
                $this->rollbackOrder($order_id);
                $objSiteSess->setRegistFlag();
                SC_Response_Ex::sendRedirect(SHOPPING_PAYMENT_URLPATH);
                exit;
                break;
            case "send": 
                //エラーチェック
                $this->arrErr = $objFormParam->checkError();
                if(count($this->arrErr) == 0){
                    // データ作成
                    $this->store = $objFormParam->getValue("convenience");
                    $arrSendData = $this->createSendData($order_id);
                    // 送信先URLへPOST
                    $res = LC_Helper_Mdl_Dchk::POST(DCHK_CONVENIENCE_URL,$arrSendData);
                    $res = explode("\r\n", mb_convert_encoding($res,"UTF-8","SJIS"));
                    if(is_array($res) and count($res) >= 3 ){
                        if($res[0] == "OK"){
                            $this->tpl_mainpage = "shopping/complete.tpl";
                            $this->setCompleteParam($res);
                            $objDckMail = new SC_Helper_Mail_Ex_Dchk();
                            $objDckMail->sfSendOrderMail($order_id, SC_MobileUserAgent_Ex::isMobile() ? 2 : 1);
                            $this->arrInfo = SC_Helper_DB_Ex::sfGetBasisData();
                        }else{
                            $this->arrErr +=array("message"=> $res[2]);
                        }
                    }else{
                        $this->arrErr +=array("message"=> DCHK_ERROR_CONVENIENCE_CONNECT);
                    }
                }
                break;
            default:
                break;
                
        }
        $this->arrForm = $objFormParam->getFormParamList();
        $this->sendResponse();
    }


    /**
     * 決済ごとの独自情報を取得します。
     */
    function getExtData() {
        $limit = date("Ymd",( time() + 86400 * $this->limitdate));
        return array('KAKUTEI' => 1,"KIGEN"=>$limit);
    }
    

    function initParam(&$objFormParam) {
        $objFormParam->addParam("利用コンビニ", "convenience",INT_LEN,"KVa",array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));	
    }

    function setCompleteParam($res) {
        $order_id = $_SESSION['order_id'];

        if (SC_Utils_Ex::isBlank($order_id) or !SC_Utils_Ex::sfIsInt($order_id)) {
            return;
        } 

        $objQuery =& SC_Query_Ex::getSingletonInstance();
        $this->arrOther = array(
            "title"=>array("value"=>"コンビニ決済情報","name"=>"コンビニ決済"),
//            "支払期限"=>array("value"=>$res[4],"name"=>"支払期限"),
            "指定コンビ二"=>array("value"=>$this->arrConvenience[$this->store],"name"=>"指定コンビ二")
        );
//ここから追加部分
        if($this->store == "71"){
        $this->arrOther += array("お支払方法"=>array("value"=>"次のURLを携帯電話に転送してコンビニでお支払ください。","name"=>"お支払方法"));
        }else{
        $this->arrOther += array("お支払方法"=>array("value"=>"次の番号を紙などに控えてコンビニにてお支払ください。","name"=>"お支払方法"));
        }
        switch ($this->store) {
          case '1':
            $this->arrOther += array("受付番号"=>array("value"=>"<font color='red'>".$res[3]."</font>","name"=>"受付番号"));
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("ローソン支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/lawson.html target='_blank'>http://www.paydesign.co.jp/service/guide/lawson.html</a>","name"=>"ローソンでのお支払方法"));
            $this->arrOther += array("セイコーマート支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/seico.html target='_blank'>http://www.paydesign.co.jp/service/guide/seico.html</a>","name"=>"セイコーマートでのお支払方法"));
            $this->arrOther += array("ミニストップ支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/ministop.html target='_blank'>http://www.paydesign.co.jp/service/guide/ministop.html</a>\n","name"=>"ミニストップでのお支払方法"));
          break;
          case '2':
            $this->arrOther += array("払込票番号"=>array("value"=>"<font color='red'>".$res[3]."</font>","name"=>"払込票番号"));        
            $this->arrOther += array("払込票"=>array("value"=>'<a href='.$res[6].' target="_blank">'.$res[6]."</a>","name"=>"払込票"));        
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("セブン支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/seven.html target='_blank'>http://www.paydesign.co.jp/service/guide/seven.html</a>\n","name"=>"セブンイレブンでのお支払方法"));
          break;
          case '3':
            $this->arrOther += array("第1番号（企業コード） - 第2番号（注文番号）"=>array("value"=>"<font color='red'>".$res[3]."</font>","name"=>"第1番号（企業コード） - 第2番号（注文番号）"));
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("ファミマ支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/famima.html target='_blank'>http://www.paydesign.co.jp/service/guide/famima.html</a>\n","name"=>"ファミリーマートでのお支払方法"));
          break;
          case '71':
            $this->arrOther += array("支払用バーコードURL"=>array("value"=>'<a href='.$res[6].' target="_blank">'.$res[6]."</a>","name"=>"支払用バーコードURL"));
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("ヤマザキ支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/yamazaki.html target='_blank'>http://www.paydesign.co.jp/service/guide/yamazaki.html</a>\n","name"=>"デイリーヤマザキ・ヤマザキデイリーストアーでのお支払方法"));
          break;
          case '73':
            $this->arrOther += array("オンライン決済番号"=>array("value"=>"<font color='red'>".$res[3]."</font>","name"=>"オンライン決済番号"));        
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("オンライン決済支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/onlinekessai.html target='_blank'>http://www.paydesign.co.jp/service/guide/onlinekessai.html</a>\n","name"=>"サークルKサンクス・ミニストップ・デイリーヤマザキ・ヤマザキデイリーストアーでのお支払方法"));
          break;
        }
//ここまで追加部分
/*
        if($this->store == "71"){
            $this->arrOther += array("支払用URL"=>array("value"=>'<a href='.$res[6].' target="_blank">'.$res[6]."</a>","name"=>"支払用URL"));
        }else{
            $this->arrOther += array("支払番号"=>array("value"=>$res[3],"name"=>"支払番号"));        
        }
*/
        $sqlval = array(
                    "memo06"=>$res[3],  //結果コード
                    "memo02"=> serialize($this->arrOther) ,  //支払期限など
                    "status"=>ORDER_PAY_WAIT ,
                    "dchk_status" =>DCHK_STATUS_WAIT
                  );
        $objQuery->update('dtb_order',$sqlval, 'order_id = ?', array($_SESSION['order_id']));
        unset($_SESSION['order_id']);


    }

    //決済金額が0円の時は決済をスキップ
    function skipSettlement($order_id) {
        LC_Helper_Mdl_Dchk::log('決済金額が0円のため決済処理をスキップします。');
        $sqlval = array(
            'payment_date' => 'now()', // 入金日時
            'update_date' => 'now()',
            'dchk_status' => DCHK_STATUS_WAIT
        );
        $objPurchase = new SC_Helper_Purchase_Ex();
        $objPurchase->sfUpdateOrderStatus($order_id, ORDER_NEW, null, null, $sqlval);

        $objSiteSess = new SC_SiteSession_Ex();
        $objSiteSess->setRegistFlag();
        $objPurchase = new SC_Helper_Purchase_Ex();
        $objPurchase->sendOrderMail($order_id);
        LC_Helper_Mdl_Dchk::log('完了ページに移動します');
        SC_Response_Ex::sendRedirect(SHOPPING_COMPLETE_URLPATH);
   }

    function viewError() {
        $this->tpl_mainpage = LC_Helper_Mdl_Dchk::getTemplateDir('credit_error.tpl');
        $this->sendResponse();
    }

    function rollbackUsePoint($order_id){
        $objPurchase = new SC_Helper_Purchase_Ex();
        $arrOrder = $objPurchase->getOrder($order_id);

        if($arrOrder['use_point'] && $arrOrder['del_flg'] == 0){
            $objQuery =& SC_Query_Ex::getSingletonInstance();
            $sqlval = array();
            $where = '';
            $arrVal = array();
            $arrRawSql = array();
            $arrRawSqlVal = array();

            $sqlval['update_date'] = 'Now()';
            $arrRawSql['point'] = 'point + ?';
            $arrRawSqlVal[] = $arrOrder['use_point'];
            $where .= 'customer_id = ?';
            $arrVal[] = $arrOrder['customer_id'];

            $objQuery->update('dtb_customer', $sqlval, $where, $arrVal, $arrRawSql, $arrRawSqlVal);
        }
    }

}
?>
